/*
================================================================================
                            COPYRIGHT NOTICE

    Copyright (C) 2000 VMIC
    International Copyright Secured.  All Rights Reserved.

--------------------------------------------------------------------------------
    Filename: uvi_ioctl.h  Version: 1.1  Modification Date: 00/03/21 10:14:39
--------------------------------------------------------------------------------
    Description: ioctl definitions for the Universe driver for Linux
--------------------------------------------------------------------------------

    Revision History:
    Date         Who  Ver   Reason For Change
    -----------  ---  ----  ----------------------------------------------------
    21-MAR-2000  JW   1.1   Created. 

================================================================================
@(#)uvi_ioctl.h 1.1 00/06/27 VMIC
*/

#ifndef __UVI_IOCTL_H
#define __UVI_IOCTL_H

#include <linux/ioctl.h>
#include "uvi_universe.h"

/******************************************************************************/

/* The Universe magic number */
#define UVI_MAGIC 0xbe


/*******************************************************************************/

/* Interrupt Events */

/* #define IOCTL_RMNET_SEND_EVENT            _IOW(RMNET_MAGIC,  5, RMNEVENTINFO) */
#define IOCTL_UVI_ENABLE_EVENT          _IOWR(UVI_MAGIC,  3, UVI_UINT32)
#define IOCTL_UVI_RECEIVE_EVENT         _IOWR(UVI_MAGIC,  4, UVI_UINT32)
#define IOCTL_UVI_DISABLE_EVENT         _IOWR(UVI_MAGIC,  5, UVI_UINT32)


/******************************************************************************/

/* Data Transfer */

#define IOCTL_UVI_GET_WINDOW         _IOWR(UVI_MAGIC, 1, struct uviVmeWindowParameters)

#define IOCTL_UVI_CLOSE_WINDOW       _IOWR(UVI_MAGIC, 2, struct uviVmeWindowParameters)

/******************************************************************************/

/* Debugging */

#define IOCTL_UVI_GET_DEBUG_FLAGS    _IOR(UVI_MAGIC, 21, UVI_UINT32)
#define IOCTL_UVI_SET_DEBUG_FLAGS    _IOW(UVI_MAGIC, 22, UVI_UINT32)


/******************************************************************************/

/* Utility */

#define IOCTL_UVI_PROBE_ADDRESS      _IOW(UVI_MAGIC, 31, struct uviVmeWindowParameters)


/******************************************************************************/


/******************************************************************************/

/* Dma Transfer sjl */

#define IOCTL_UVI_DMAIO              _IOWR(UVI_MAGIC, 32, struct uviVmeDmaParameters)
#define IOCTL_UVI_REQ_DMA            _IOWR(UVI_MAGIC, 33, UVI_UINT32)
#define IOCTL_UVI_RELEASE_DMA        _IOWR(UVI_MAGIC, 34, UVI_UINT32)
#define IOCTL_UVI_CANCEL_DMA_WAIT    _IOWR(UVI_MAGIC, 35, UVI_UINT32)
#define IOCTL_UVI_WAIT_DMA           _IOWR(UVI_MAGIC, 36, struct uviVmeDmaSetup)

/******************************************************************************/

/******************************************************************************/

/* Slave Window  sjl */

#define IOCTL_UVI_SLAVE_OPEN         _IOW(UVI_MAGIC, 40, struct uviVmeSlaveWinParameters) 
#define IOCTL_UVI_SLAVE_CLOSE        _IOW(UVI_MAGIC, 41, struct uviVmeSlaveCloseParams)

/******************************************************************************/

/******************************************************************************/

/* mailbox */

#define IOCTL_UVI_REQ_MB             _IOWR(UVI_MAGIC, 42, UVI_UINT32)
#define IOCTL_UVI_RELEASE_MB         _IOWR(UVI_MAGIC, 43, UVI_UINT32)
#define IOCTL_UVI_CANCEL_MB          _IOWR(UVI_MAGIC, 44, UVI_UINT32)
#define IOCTL_UVI_ENABLE_MB          _IOWR(UVI_MAGIC, 45, UVI_UINT32)


/* Service VME interrupts */
#define IOCTL_UVI_CANCEL_VME_INT     _IOWR(UVI_MAGIC, 46, struct uviInterruptParameters)  
#define IOCTL_UVI_REQ_VME_INT        _IOWR(UVI_MAGIC, 47, struct uviInterruptParameters)  
#define IOCTL_UVI_RELEASE_VME_INT    _IOWR(UVI_MAGIC, 48, struct uviInterruptParameters) 
#define IOCTL_UVI_WAIT_VME_INT       _IOWR(UVI_MAGIC, 49, struct uviInterruptParameters)


#endif  /* __UVI_IOCTL_H */
